<?php header('Content-Type: text/html; charset=utf-8') ; ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<!--
Copyright Zed Sellig, 15 février 2009 et 1er décembre 2016
sellig.zed(ad.no.spam)myriapyle.info 
==========================================================================
Ce logiciel est un programme informatique servant à tester la validité des liens
hypertexte contenus dans un fichier. 

Ce logiciel est régi par la licence CeCILL soumise au droit français et
respectant les principes de diffusion des logiciels libres. Vous pouvez
utiliser, modifier et/ou redistribuer ce programme sous les conditions
de la licence CeCILL telle que diffusée par le CEA, le CNRS et l'INRIA 
sur le site "http://www.cecill.info".

En contrepartie de l'accessibilité au code source et des droits de copie,
de modification et de redistribution accordés par cette licence, il n'est
offert aux utilisateurs qu'une garantie limitée.  Pour les mêmes raisons,
seule une responsabilité restreinte pèse sur l'auteur du programme,  le
titulaire des droits patrimoniaux et les concédants successifs.

A cet égard  l'attention de l'utilisateur est attirée sur les risques
associés au chargement,  à  l'utilisation,  à la modification et/ou au
développement et à la reproduction du logiciel par l'utilisateur étant 
donné sa spécificité de logiciel libre, qui peut le rendre complexe à
manipuler et qui le réserve donc à des développeurs et des professionnels
avertis possédant  des  connaissances  informatiques approfondies.  Les
utilisateurs sont donc invités à charger  et  tester  l'adéquation  du
logiciel à leurs besoins dans des conditions permettant d'assurer la
sécurité de leurs systèmes et ou de leurs données et, plus généralement, 
à l'utiliser et l'exploiter dans les mêmes conditions de sécurité. 

Le fait que vous puissiez accéder à cet en-tête signifie que vous avez 
pris connaissance de la licence CeCILL, et que vous en avez accepté les
termes.
==========================================================================
This software is a computer program whose purpose is to assess the
validity of links url contained in a file.

This software is governed by the CeCILL license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this heading means that you have had
knowledge of the CeCILL license and that you accept its terms.
-->

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
	<title>HyperTeste</title>
	
	<link rel="shortcut icon" type="image/x-icon" href="./favicon.ico" />
	<link rel="icon" type="image/ico" href="./favicon.ico" />
	<link rel="stylesheet" type="text/css" href="./hyperteste06.05.css" />

	<meta http-equiv="Content-Type" content="text/HTML; charset=utf-8" />

	<meta name="description" content="application en AJAX pour test des liens contenus dans un fichier" />
	<meta name="keywords"
              content="application, logiciel, libre, free, software, ajax, javascript, test, liens, links, url, http, xmlhttprequest, webmaster" />

	<script type="text/javascript" src="./hyperteste06.05.js"></script>
</head>

<body>
<!-- ================================================================================================================= -->
<!-- =========================================== PRESENTATION ======================================================== -->
<!-- ================================================================================================================= -->
<h1 id="presentation">HyperTeste</h1>
<p class="lien_interne"><img src="./favicon.ico" alt="favicon" />&nbsp;&nbsp;&nbsp;<a href="#exec">Aller directement au formulaire</a></p>
<h2>Introduction</h2>
<p>Cette page contient une petite application nommée <i>HyperTeste</i>, utile au gestionnaire de site internet. Son but est de faciliter la
maintenance d'un site en automatisant le test des liens hypertextuels contenus dans un fichier. A cet effet, le fichier soumis
est lu, les url en sont extraites et, pour chaque url, une tentative de connexion est faite et fournit le diagnostic des liens.</p>
<p>L'ensemble des fichiers utiles pour employer HyperTeste est disponible sous la forme d'une archive zip au paragraphe "historique des versions"
au bas de cette page. Elle contient un dossier comportant cette page php, l'icône de l'application, la feuille de style et les routines javascript,
un fichier d'essai et un exemple de sortie au format pdf.</p>

<h2>Mode d'emploi</h2>
<p>Pour utiliser la version xy.z, les trois fichiers <i>hyperteste.htm</i>, <i>hypertestexy.z.js</i> et <i>hypertestexy.z.css</i> doivent se
trouver dans le même dossier, sur le serveur hébergeant le fichier à tester. Hyperteste ne fonctionne que si elle est <strong>dans le même
domaine que le fichier à traiter</strong>. Pour employer l'application, il suffit d'ouvrir hyperteste.php dans un navigateur (avec javascript
activé).</p>
<p><strong>1. Dans le champ texte du formulaire, entrer le nom du fichier qui contient les url</strong>, avec son chemin 
d'accès s'il n'est pas dans le dossier d'HyperTeste.<br />
Ce peut être un fichier htm(l) ou n'importe quel autre fichier (javascript par exemple), du moment que les url commencent par 
<strong>http://</strong>, par 
<strong>https://</strong> ou par <strong>ftp://</strong>. Pour mémoire, les caractères <strong>permis</strong> dans les url sont les
suivants&nbsp;:</p>
<p class="central">[]a-zA-Z0-9.~:'_#@!&amp;$/()?*+,;=%-</p>
<p>Le fichier soumis est traité sur la machine cliente avec AJAX pour en extraire les liens qui sont ensuite testés en php. Pendant cette
interrogation (dont la durée est limitée), le navigateur semble figé puisqu'il attend la fin de l'exécution du code php pour afficher les
résultats. Un majorant du temps d'attente est donné par l'application.</p>

<p><strong>2. Choisir les sorties voulues.</strong> Par défaut, l'application teste tous les liens trouvés, en http ou ftp mais il est possible
de se limiter à l'un des deux protocoles. Attention cependant, il semble que certains serveurs refusent l'interrogation pour le ftp d'où une fausse
alerte de lien cassé.</p>

<p><strong>3. Cliquer sur le bouton "Analyser le fichier"</strong> pour extraire les liens.</p>

<p><strong>4. Cliquer sur le bouton "Tester les liens"</strong> qui s'affiche en même temps que les liens extraits. Lorsque tous les tests sont
effectués, le résultat est affiché sous la forme d'une liste de liens cliquables suivis, selon le cas, d'une étiquette 
<span style="background-color: chartreuse">lien valide</span> ou <span style="background-color: tomato">controle requis</span>. Un lien
signalé comme à contrôler n'est pas forcément cassé : ce résultat peut découler d'une erreur non critique ou bien d'un délai de réaction trop
long ; ceci semble se produire plus souvent avec les url en https.
Un clic sur le lien permet de vérifier le résultat par l'ouverture du document cible dans une nouvelle fenêtre.</p>

<p>Exemple de <a href="./HyperTeste.pdf">sortie</a> obtenue en appliquant HyperTeste au fichier <a href="./essai.htm">essai.htm</a>.</p>
<!-- ================================================================================================================= -->
<!-- =========================================== EXECUTION =========================================================== -->
<!-- ================================================================================================================= -->
<h2 id="exec">Exécution</h2>
<p class="lien_interne"><img src="./favicon.ico" alt="favicon" /> <a href="#presentation">Remonter à la présentation de
l'application</a></p>

<form id="EntreNomFichier" action="hyperteste.php" class="formulaire">
<h3>Entrée des données</h3>
<p class="inepoute"><strong>Entrer le nom de fichier :</strong><br />
<input size="120" onkeypress="return Envoi(event)" /><br />
Exemples de syntaxe correcte : <strong>essai.htm</strong>, <strong>../index.htm</strong>,
<strong>http://www.myriapyle.net/hyperteste.php/essai.htm</strong> (seul un fichier dans le même domaine que l'application peut être testé).</p>

<fieldset>
<legend>Paramétrage</legend>
Tester : <input type="radio" name="typedurl" value="tous_tp" id="typedurl0" checked="checked" />
<label for="typedurl0">Tous les liens http et ftp</label>
<input type="radio" name="typedurl" value="_http" id="typedurl1" />
<label for="typedurl1">Seulement les liens http</label>
<input type="radio" name="typedurl" value="_ftp" id="typedurl2" />
<label for="typedurl2">Seulement les liens ftp</label>
</fieldset>

<p class="inepoute"><strong>Appuyer sur le bouton pour… : </strong>
<input type="button" value="Analyser le fichier" id="LitFichier" onclick="ChargeFichier(elements[0].value) ;" /></p>
</form>

<div id="compteur" class="aoutepoute"><p></p></div>
<div id="affichage" class="aoutepoute"><p></p></div>

<form id="formtest"  method="post" action="hyperteste.php" enctype="multipart/form-data"></form>
<!-- ================================= -->
<!-- Début du programme de test en php -->
<!-- ================================= -->
<div id="divphp">
<?php
// Cette fonction teste le lien en l'ouvrant avec fopen, avec un délai de péremption de 1,5 seconde
function test($link)
        {       // cette technique a été testée avec succès sur des liens http, https et ftp. Ce dernier protocole répond parfois de façon erronée.
        $contexte = stream_context_create( array("http" => array("timeout" => 1.5),"ftp"=>array("timeout" => 1.5) )  ) ;
        $a = fopen($link, 'r', false, $contexte);
        fclose($link) ;
        // var_dump($http_response_header);                // pour analyse
        return $a?"lien valide":"controle requis" ;
        }
// Corps du programme php
// Le formulaire exploité a été construit et rempli en javascript (module externe)
if (isset($_POST['nblienstest']))
        {
        $nblienstest=(strip_tags($_POST['nblienstest'])) ;
        $urlfichier = (strip_tags($_POST['urlfichier'])) ;                              // Ajout 6.03
        echo "Fichier traité : $urlfichier<br />\n" ;                                   // Rappel du nom de fichier dans la page de résultats
        echo "Nombre de liens dans le fichier : $nblienstest <br />\n" ;

        for ($ilien = 0 ; $ilien < $nblienstest ; $ilien++)
                {
                echo ($ilien+1) . ', ' ;                 // version 06.02, déplacé ici pour vérifier l'entrée dans la boucle
                $identifiant = 'idURL' . $ilien ;
                $liencourant = (strip_tags($_POST[$identifiant])) ;
                $resultatcourant = test($liencourant) ;
                if ($resultatcourant == "lien valide")
                        {
                        $resultatcourant = '<span style="background-color: chartreuse">lien valide</span>' ;
                        }
                else
                        {
                        $resultatcourant = '<span style="background-color: tomato">controle requis</span>' ;
                        }
                echo '<a href="' . $liencourant . '" id="'. $identifiant . '" target="_blank" />' 
                        . $liencourant .'</a>  : ' . $resultatcourant . "<br />\n" ;
                }
        }
else
        { 
        // echo "Pas de données reçues\n" ;
        }
?>
</div>
<!-- =============================== -->
<!-- Fin du programme de test en php -->
<!-- =============================== -->

<p></p>
<hr />

<h3>Historique des versions</h3>

<ul>
<li>Les versions antérieures à 04.2 étaient des versions de mise au point, non diffusées.</li>
<li>La version 04.2 ne testait que les url de la forme <i>http://une_url</i> comprises entre deux guillemets doubles.</li>
<li>La version 04.3 extrait les url de la forme <i>http://une_url</i> ou <i>ftp://adresse</i>, placées entre deux caractères 
encadrants quelconques,
dont le deuxième est suivi par un espace ou un &gt;. Toutefois, la consultation d'un site ftp renvoie toujours une erreur.
S'il y a peu de liens ftp, cette méthode permet de les identifier et de les tester manuellement en cliquant dessus dans la zone
de sortie des messages de l'application. S'il y a surtout des liens ftp, cette application HyperTeste n'est pas bien adaptée.</li>
<li>La version 04.4 ajoute un temps d'attente maximal au bout duquel chaque requête est interrompue si elle n'a pas abouti.
Par ailleurs, elle détecte et signale une éventuelle erreur à l'ouverture du fichier soumis.</li>
<li>La version 04.5 permet à l'utilisateur de modifier la valeur du
temps d'attente maximal au bout duquel chaque requête est interrompue si elle n'a pas abouti.
Ce délai d'expiration est proposé à 30 secondes par défaut.</li>
<li>La version 04.6 est identique à la 04.5. Elle corrige simplement une erreur de rédaction
du mode d'emploi et améliore la mise en page.</li>
<li>La version 04.7 offre à l'utilisateur la possibilité de choisir s'il veut
extraire et tester tous les liens http et ftp (option par défaut) ou bien s'il souhaite
se limiter à l'un des deux. Elle corrige une faute de frappe qui avait exclu le _ de la
classe des caractères admis dans une url. En outre, cette version change un peu la logique d'extraction
des liens : il n'est pas indispensable que l'url soit comprise entre deux limiteurs spécifiques,
elle est extraite si elle est entre deux ' ou entre deux ", ou encore si elle est suivie d'un espace
ou d'un quelconque caractère non permis dans les url. Sont aussi extraites les url en début
ou en fin de ligne ou seules sur une ligne. Cela permet de traiter de simples fichiers textes, par exemple, 
qui citent des url au fil de la rédaction, ainsi que des listes d'url. 
Enfin, cette version avertit l'utilisateur si l'application ne peut pas ouvrir le fichier soumis ou 
ne trouve pas de liens du type requis dans ce fichier.</li>
<li>La version 05.01 est marquée par le choix d'une diffusion sous licence CeCILL V2. Elle offre aussi l'option
d'afficher les liens extraits sous la forme d'une simple liste, sans commentaires. Pour fêter le passage
à la version 5, l'application s'agrémente d'une icône de barre d'adresse.</li>
<li> La version 6.01 adopte le php pour tester les liens, au lieu de l'Ajax dont l'interrogation interdomaine est rendue aléatoire par le
renforcement de la sécurité des sites.</li>
<li> Lorsque les liens http sont demandés, la version 6.02 extrait aussi les liens https éventuellement présents.
</li>
<li>La version 6.02 omettait d'extraire un lien https en début ou en fin de ligne ou seul sur une ligne. La version 6.03 corrige cet oubli. Elle
rappelle aussi le nom du fichier dans la page de résultats. Le mode d'emploi est légèrement amélioré.</li>
<li>La version 6.04 remplace l'étiquette "lien rompu" par "controle requis".
Archive pour téléchargement au format zip : <a href="./archives/hyperteste06.04.zip">hyperteste06.04.zip</a>
(1,2 Mo environ).</li>
<li>La version 6.05 corrige une erreur d'expression rationnelle dans le nettoyage des fragments de texte contenant une url qui tronquait
d'une lettre certaines adresses.</li>
</ul>

<h3>Réserve</h3>

<p>L'auteur de ce script a produit ses meilleurs efforts pour obtenir un bon fonctionnement mais il ne garantit pas qu'il est sans erreurs ni qu'il
sera compatible avec la configuration de l'utilisateur. Ce dernier doit donc s'assurer de la satisfaction de ses besoins par le logiciel et de
l'absence de risques pour ses biens. Dans cet esprit, cette application est diffusée sous licence
<a href="http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html">CeCILL</a>.</p>

<hr />
<!-- Le texte du script suivant avec correction du 4.6.12 passe le validateur HTML 4 Strict et HTML 5 grâce à \/h6 dans document.write() -->
<script type="text/JavaScript">
//<![CDATA[
//
// met la date sous la forme dd-mmm-aa. exemple: 12-Jan-99
//
function date_ddmmmyy(date)
{
  var d = date.getDate();
  var m = date.getMonth() + 1;
  var y = date.getYear();

  // traite les valeurs de dates propres de IE et NS pour l'an 2000.

  if(y >= 2000)
  	{
    	y -= 2000;
  	}
  if(y >= 100)
  	{
    	y -= 100;
  	}


  var mmm = 
    ( 1==m)?'Jan':( 2==m)?'Fev':(3==m)?'Mar':
    ( 4==m)?'Avr':( 5==m)?'Mai':(6==m)?'Jun':
    ( 7==m)?'Jul':( 8==m)?'Aou':(9==m)?'Sep':
    (10==m)?'Oct':(11==m)?'Nov':'Dec';

  return "" +
    (d<10?"0"+d:d) + "-" +
    mmm + "-" +
    (y<10?"0"+y:y);
}

//
// obtient la date de modification du document en cours.
//
function date_lastmodified()
{
  var lmd = document.lastModified;
  var s   = "Unknown";
  var d1;

  // Voit si la date est correcte avant de poursuivre
  if(0 != (d1=Date.parse(lmd)))
  {
    s = "" + date_ddmmmyy(new Date(d1));
  }

  return s;
}

//
// finalement affiche la date de modification sous la forme DD-MMM-AA
//
document.write("<h6>Mis &agrave; jour le " + date_lastmodified() + ".<\/h6>");

//]]>
</script>
<hr />
<p><small>Version 06.05<br />&#169;Sellig Zed, 2009-2020. Diffusé sous 
<a href="http://www.cecill.info/licences/Licence_CeCILL_V2-fr.html">CeCILL</a>.</small></p>
<hr />
<p><a href="http://validator.w3.org/check?uri=http%3A%2F%2Fwww.myriapyle.net%2Fhyperteste.php%2Fhyperteste.php">
<img src="http://www.w3.org/Icons/valid-xhtml10" alt="logo xhtml 1.0" title="logo xhtml 1.0" height="31" width="88" />
<span style="background-color:darkgreen ; color:white">Validé avec le vérificateur du W3C</span></a></p>

</body>
</html>
